function [ODEfctname, ODEfilefullpath, DATAfctname, EVENTfctname, EVENTASSGNfctname] = TAcreateTempODEfile(varargin)
% Function used to evaluate parameter points of SDE models

% Original function (SBcreateTempODEfile.m as part of SBtoolbox2, www.sbtoolbox2.org) 
% modified by Mikael Sunnaker, mikael.sunnaker@gmail.com

% Information:
% ============
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  
% USA.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PROCESS VARIABLE INPUT ARGUMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
eventFlag = 0;
dataFileFlag = 0;
augmKernelName = '';
Asym = {''};
if nargin == 1,
    sbm = varargin{1};
elseif nargin == 2,
    sbm = varargin{1};
    dataFileFlag = varargin{2};
elseif nargin == 3,
    sbm = varargin{1};
    dataFileFlag = varargin{2};
    eventFlag = varargin{3};
elseif nargin == 4,
    sbm = varargin{1};
    dataFileFlag = varargin{2};
    eventFlag = varargin{3};
    augmKernelName = varargin{4};
elseif nargin == 5,
    sbm = varargin{1};
    dataFileFlag = varargin{2};
    eventFlag = varargin{3};
    augmKernelName = varargin{4};
    Asym = varargin{5};
else
    error('Incorrect number of input arguments.');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GET TEMP FILE NAME
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get temporary filenme
tempfilefullpath = tempnameSB;
[pathstr,tempfilename,ext,versn] = fileparts(tempfilefullpath);     

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CREATE THE FILES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tempFlag = 1; % to avoid the event warning when creating files for models with events w/o setting the event flag
TAcreateODEfile(sbm,tempfilefullpath,dataFileFlag,eventFlag,augmKernelName,tempFlag,Asym);
rehash toolbox;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CREATE THE FILE NAMES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ODEfctname = tempfilename;
if dataFileFlag == 1,
    DATAfctname = strcat('datafile_',ODEfctname);
else 
    DATAfctname = '';
end
if eventFlag == 1,
    EVENTfctname = strcat('event_',ODEfctname);
    EVENTASSGNfctname = strcat('event_assignment_',ODEfctname);
else
    EVENTfctname = '';
    EVENTASSGNfctname = '';
end
ODEfilefullpath = strcat(tempfilefullpath,'.m');

