function [logL] = logLikelihoodFunction(eps,R,nrTp) 

% Information:
% ============
% Written by: Mikael Sunnaker, mikael.sunnaker@gmail.com
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  
% USA.

%the sum over time points over 
valSum = 0;

for i = 1:nrTp
    %get the contribution of the new time point
    v_k = eps(i).vect'*(R(i).mat\eps(i).vect);
    %calculate the sum
    valSum = valSum + log(det(R(i).mat)) + v_k;
end

%add the constant term to the likelihood function
valSum = valSum + nrTp*size(R(1).mat,1)*log(2*pi);

%get the loglikelihood function from the calculated sum
logL = -0.5 * valSum;

return


